package edu.mermet.tp8.dialog;

import java.awt.Container;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import java.awt.BorderLayout;
import javax.swing.BoxLayout;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.actions.ActionQuitter;
import edu.mermet.tp8.actions.ActionValider;

public class ConfigurationMenu extends JDialog {
    Application appli;
    JRadioButton autoConv;
	JRadioButton affichConv;
	JRadioButton cachConv;
    JRadioButton autoTexte;
	JRadioButton affichTexte;
	JRadioButton cachTexte;
    JRadioButton autoDiapo;
	JRadioButton affichDiapo;
	JRadioButton cachDiapo;
	JRadioButton autoBouton;
	JRadioButton affichBouton;
	JRadioButton cachBouton;

    public ConfigurationMenu(Application appli) {
        super(appli, "Configuration des menus");
        this.appli = appli;
        init();
        pack();
        this.setDefaultCloseOperation(HIDE_ON_CLOSE);
        //this.addWindowListener(new EcouteurCommentFaire(f.getActionCommentFaire()));
    }

    public void init() {
		Container cont = this.getContentPane();
		BoxLayout box = new BoxLayout(cont, BoxLayout.Y_AXIS);
		
		cont.setLayout(box);
		
		//partie conversions
		JPanel panel = new JPanel();
		JLabel conv = new JLabel("Conversion Celsius/Farenheit");
		ButtonGroup groupConv = new ButtonGroup();
		autoConv = new JRadioButton("Auto");
		affichConv = new JRadioButton("Afficher");
		cachConv = new JRadioButton("Cacher");
		
		autoConv.setActionCommand("Auto");
		affichConv.setActionCommand("Afficher");
		cachConv.setActionCommand("Cacher");
		
		groupConv.add(autoConv);
		groupConv.add(affichConv);
		groupConv.add(cachConv);
		
		panel.add(conv);
		panel.add(autoConv);
		panel.add(affichConv);
		panel.add(cachConv);
		
		//partie saisie de texte
		JPanel textP = new JPanel();
		JLabel textL = new JLabel("Saisie de texte");
		ButtonGroup groupText = new ButtonGroup();
		
		autoTexte = new JRadioButton("Auto");
		affichTexte = new JRadioButton("Afficher");
		cachTexte = new JRadioButton("Cacher");
	
		autoTexte.setActionCommand("Auto");
		affichTexte.setActionCommand("Afficher");
		cachTexte.setActionCommand("Cacher");
		
		groupText.add(autoTexte);
		groupText.add(affichTexte);
		groupText.add(cachTexte);
		
		textP.add(textL);
		textP.add(autoTexte);
		textP.add(affichTexte);
		textP.add(cachTexte);
		
		//partie diaporama
		JPanel diapoP = new JPanel();
		JLabel diapoL = new JLabel("Diaporama");
		ButtonGroup groupDiapo = new ButtonGroup();
		
		autoDiapo = new JRadioButton("Auto");
		affichDiapo = new JRadioButton("Afficher");
		cachDiapo = new JRadioButton("Cacher");
		
		autoDiapo.setActionCommand("Auto");
		affichDiapo.setActionCommand("Afficher");
		cachDiapo.setActionCommand("Cacher");
		
		groupDiapo.add(autoDiapo);
		groupDiapo.add(affichDiapo);
		groupDiapo.add(cachDiapo);
		
		diapoP.add(diapoL);
		diapoP.add(autoDiapo);
		diapoP.add(affichDiapo);
		diapoP.add(cachDiapo);
		
		//partie boutons
		JPanel boutonP = new JPanel();
		JLabel boutonL = new JLabel("Boutons");
		ButtonGroup groupBouton = new ButtonGroup();
		
		autoBouton = new JRadioButton("Auto");
	    affichBouton = new JRadioButton("Afficher");
		cachBouton = new JRadioButton("Cacher");
		
		autoBouton.setActionCommand("Auto");
		affichBouton.setActionCommand("Afficher");
		cachBouton.setActionCommand("Cacher");
		
		groupBouton.add(autoBouton);
		groupBouton.add(affichBouton);
		groupBouton.add(cachBouton);
		
		boutonP.add(boutonL);
		boutonP.add(autoBouton);
		boutonP.add(affichBouton);
		boutonP.add(cachBouton);
		
		cont.add(panel);
		cont.add(textP);
		cont.add(diapoP);
		cont.add(boutonP);
		
		boutonsAff();
		
		//boutons quitter et valider
		JPanel boutonsPanel = new JPanel();
		JButton valider = new JButton("Valider");
		valider.addActionListener(new ActionValider(groupConv, groupText, groupDiapo, groupBouton, appli, this));
		JButton quitter = new JButton("Quitter");
		quitter.addActionListener(new ActionQuitter(this));
		
		boutonsPanel.add(valider);
		boutonsPanel.add(quitter);
		add(boutonsPanel, BorderLayout.SOUTH);
	}

    public void boutonsAff() {
        try {
            
            Properties p = System.getProperties();            
            String name = p.getProperty("user.name");
            
            InputStream input = new FileInputStream("src/main/java/edu/mermet/tp8/donnees/"+ name +".properties");
            
            Properties prop = new Properties();

            prop.load(input);
            
            if(prop.getProperty("conv").contains("Auto")) {
                autoConv.setSelected(true);
            }else if (prop.getProperty("conv").contains("Afficher")) {
                affichConv.setSelected(true);
            }else {
                cachConv.setSelected(true);
            }
            
            if(prop.getProperty("texte").contains("Auto")) {
                autoTexte.setSelected(true);
            }else if (prop.getProperty("texte").contains("Afficher")) {
                affichTexte.setSelected(true);
            }else {
                cachTexte.setSelected(true);
            }
            
            if(prop.getProperty("diapo").contains("Auto")) {
                autoDiapo.setSelected(true);
            }else if (prop.getProperty("diapo").contains("Afficher")) {
                affichDiapo.setSelected(true);
            }else {
                cachDiapo.setSelected(true);
            }
            
            if(prop.getProperty("bouton").contains("Auto")) {
                autoBouton.setSelected(true);
            }else if (prop.getProperty("bouton").contains("Afficher")) {
                affichBouton.setSelected(true);
            }else {
                cachBouton.setSelected(true);
            }
            
        }catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}